;
; LOD Player Version 2
;
; 1Cf2
; 1D8f
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

;freqs = $0400

;freqs_add
;	DB 07,57,54,51, 48,45,43,40, 38,36,34,32 ; 00
;	DB 31,28,27,25, 24,23,21,21, 19,18,17,16 ; 12
;	DB 15,14,14,12, 12,12,10,10, 10,09,08,08 ; 24
;	DB 08,07,07,06, 06,06,05,05, 05,04,05
;	;DB 69
;	
;	DB 04 ; 36
;	DB 03,04,03,04, 03,02,03,03, 02,02,02,02 ; 48
;	DB 02,02,02,02+24			 ; 60 (63=off)
	
OFF	= $3F
	
; COMMAND BYTES

END_MARK	= $FE
SET_VOLTAB	= $FF
VOL_DN		= $FB
SETINS		= $F0
SETLEN		= $40

; Constants
base_note = -7 ; shift to Gi0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----
          
	;ALIGN 256         
PLAYER_FREQ_INIT
	;         
	; *** Freq init
	;
	LDX #(Channel1-OFS) & 255
	LDY #(Channel1-OFS) >> 8
	STX PCH1_LO
	STY PCH1_HI
	;
	LDX #(Channel2-OFS) & 255
	LDY #(Channel2-OFS) >> 8
	STX PCH2_LO
	STY PCH2_HI
	;
	LDX #(Channel3-OFS) & 255
	LDY #(Channel3-OFS) >> 8
	STX PCH3_LO
	STY PCH3_HI
	;
	LDX #$FF
	STX VOLTAB_CNT
	INX       
	STX NOTE1
	STX NOTE2
	STX NOTE3
	STX VOLUME  
	JSR res-OFS
	INX
	STX NOTELEN1
	STX NOTELEN2
	STX NOTELEN3
	JSR res-OFS
	INX		; x=2
	JSR res-OFS
	;
;	LDA freqs_add
;	STA freqs
;	LDY #$00 
;	STY freqs+1
;	;
;freq_init
;	LDA freqs-2,x
;	CLC
;	ADC freqs_add+1,y
;	STA freqs,x
;	INX
;	LDA freqs-2,x
;	ADC #$00
;	STA freqs,x
;	INY
;	INX
;	BPL freq_init
	;
	RTS

res	LDY #$00
	DB $2C
	
advance	LDY PCH1,X
	;      
	LDA PCH1_LO,x
	STA PCH_TEMP
	LDA PCH1_HI,x
	STA PCH_TEMP+1
	;
	LDA (PCH_TEMP),y	; LO byte
	STA CH1_LO,X
	INY
	LDA (PCH_TEMP),y	; HI byte
	BEQ res
	STA CH1_HI,X
	INY
	STY PCH1,X
	RTS
	
	;
	;##################
	;

PLAYER       
	LDX #$02
	;
channel_loop
	INC NOTE1,x
	;
	LDA NOTE1,x
	CMP NOTELEN1,x
	BNE channel_loop_end
	;
next_note 
	LDA CH1_LO,x
	STA CH_TEMP
	LDA CH1_HI,x
	STA CH_TEMP+1
	;
	LDY #$00
	STY NOTE1,x		; reset note counter
	;   
	LDA (CH_TEMP),y		; get byte
	INY
	;
	CMP #END_MARK		; $FF goes to new pattern
	BNE pl_10
	;
	JSR advance-OFS
	JMP next_note-OFS
	;
pl_10	CMP #SET_VOLTAB
	BNE pl_11
	;
	;LDA #$FF		; reset voltab counter
	STA VOLTAB_CNT
	;STA VOLUME		; disable SET volume
	;
	LDA (CH_TEMP),y		; get lo byte
	INY
	STA VOL_TAB-OFS+1
	;
;	LDA (CH_TEMP),y		; get hi byte
;	INY
;	STA VOL_TAB-OFS+1
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_11	CMP #VOL_DN
	BNE pl_15
	;
	LDA VOLUME
	CMP #20*9
	BEQ vol_at_min
	;
	CLC
	ADC #$09
	STA VOLUME
	;
vol_at_min
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_15	CMP #$F0		; instrument change?
	BCC pl_01
	;
	AND #$0F		; keep lower 4 bits
	STA INS_TYPE1,x   	; store instrument type
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_01	CMP #$40		; set note length?
	BCC pl_02
	;
	;SEC			; we know carry is always set
	SBC #$40
	STA NOTELEN1,x
	;
	LDA (CH_TEMP),y
	INY
	;
pl_02	; - store note!
	;
	STA TONE1,x
	;
	; --- advance pointer
	;
	TYA
	CLC
	ADC CH1_LO,x
	STA CH1_LO,x
	BCC noi_1
	INC CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	DEX
	BPL channel_loop
	;    
pl_50	
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	LDA #$20
	STA NOISE
	;
	LDX #$02		; channel 3
	JSR sound-OFS
	;
	CMP #$FE
	BNE do_ch2
	;
	LDX #$01		; channel 2
	JSR sound-OFS
	;
do_ch2	STA F1LO
	STY F1HI_x-OFS+1
	;
	LDA F1HI
	AND #$FC
F1HI_x	ORA #$00
	STA F1HI
	;
	LDX #$00		; channel 1
	JSR sound-OFS
	STA F2LO
	STY F2HI
	;
	; ---
	;
	LDX #$8D		; sta $0000 opcode
	CMP #$FE		; anti-click: don't set volume when both regs are off
	BNE sv1
	LDA F1LO
	CMP #$FE
	BNE sv1
	;
	LDX #$AD		; lda $0000 opcode
	;  
sv1	STX setvol-OFS
	LDY VOLTAB_CNT
	INY
res_v	
VOL_TAB	LDA vol_default-OFS,y
	BPL noi_v		; check for $FF
	LDY #$00		; reached, so warp
	BEQ res_v
noi_v	STY VOLTAB_CNT
	CLC
	ADC VOLUME
	TAY
	LDA volume_map-OFS,y
	;
	;ORA #$10		; volume map already has ORA #$10
	;
	;ORA #$20
	ORA NOISE
	;
;click	ORA #$00
setvol	STA $FF11		; self-mod
	;
	;LDA #$00
	;STA click+1
	;
	RTS     
	;
inst_table
	DW normal-OFS, bassdrum-OFS, snare-OFS, blipp-OFS, vib-OFS
	;
sound
	LDA TONE1,x		; normal note
	CMP #OFF
	BEQ lookup
	;
	LDA INS_TYPE1,x
	ASL a
	TAY
	LDA inst_table-OFS,y
	STA inst_jump-OFS+1
	LDA inst_table-OFS+1,y
	STA inst_jump-OFS+2
	;
inst_jump
	JMP $0000
	;
normal	LDA TONE1,x		; normal note
lookup	ASL a
	TAX
	LDA freqs-OFS,x
	LDY freqs-OFS+1,x
	RTS
	
blipp	LDA TONE1,x
	LDY NOTE1,x
	BEQ lookup
	
	CPY #$02
	BCS blipp_off
	
	CLC
	ADC #$0C
	BNE lookup
	
blipp_off
	LDA #OFF
	BNE lookup
	;
	
;arp	
;	LDY ARP_CNT		; load current arp counter
;	INY
;	CPY #$05
;	BNE *+4
;	LDY #$00
;	STY ARP_CNT
;	;CPY #$07
;	;BCC arp_ptr2
;	;LDY #$00
;	;STY ARP_CNT1,x		; auto reset every 7 frames
;arp_ptr2
;	LDA arpeggio,y		; for channel 2 (self-mod)
;	;BPL arp_add		; check for negative numbers
;	;      
;	;CMP #$FF
;	;BNE arp_restart
;	;       
;	;DEC ARP_CNT1,x
;;	LDA #OFF
;;	BNE lookup
;;arp_restart
;;	AND #$0F		; low byte is new position
;;	STA ARP_CNT1,x
;;	JMP arp			; again!
;;	;
;;arp_add 
;	CLC
;	ADC TONE1,x
;	JMP lookup-OFS
	
;	;
;slider	;
;;	LDA slide
;;	BNE sl_01
;;	DEC slide+1
;;sl_01	DEC slide
;	;  
;	LDA TICK1,x
;	BNE add1
;	;
;	LDA slide
;	LDY slide+1
;	RTS
;	;
;add1	LDA TONE1,x
;	ASL a
;	TAX
;	LDY freqs+1,x
;	LDA freqs,x
;	CLC
;	ADC #$01
;	BCC sl_03
;	INY
;sl_03	RTS
	;
;snare_off
;	LDA #OFF
;	BNE lookup
	;
snare	
	;LDA NOTE1,x
	;CMP #$02
	;BCS snare_off
	;
	LDA #$40		; turn on noise bit
	STA NOISE
	;
	LDA TONE1,x		; look up note freq
	ASL a
	TAY
	;
	LDA NOTE1,x
	;ASL a
	TAX
	LDA snare_freq-OFS,x	; 16 bit add: add snare freq
	CLC
	ADC freqs-OFS,y       
	PHA
	;LDA snare_freq+1,x
	;ADC freqs+1,y
	LDA freqs-OFS+1,y
	TAY
	PLA
	RTS
	
bassdrum
	LDA NOTE1,x
	ASL a
	TAX
	LDA bass_freq-OFS,x
	LDY bass_freq-OFS+1,x
	RTS              
	
vib	LDA NOTE1,x
	AND #$07
	TAY
	LDA vibrato-OFS,y
	BMI vib_sub1		; for negatives, different handling
	STA vib2-OFS+1
	;
	LDA TONE1,x
	ASL a
	TAX
	LDY freqs-OFS+1,x		; pre-load high byte
	LDA freqs-OFS,x		; add low byte
	CLC			; 
vib2	ADC #$01		;
	BCC vib3		; if carry is still clear, then we're done
	INY			; otherwise, increment high byte
vib3	RTS
	;
vib_sub1
	AND #$7F
	STA vib4-OFS+1
	;
	LDA TONE1,x
	ASL a
	TAX
	LDY freqs-OFS+1,x
	LDA freqs-OFS,x
	SEC
vib4	SBC #$01
	BCS vib5
	DEY  
vib5	RTS
;
;glide_2	JMP vib-OFS
;
;glide	LDA TICK1,x
;	BEQ glide_1
;	;
;	;
;	;
;	CMP #$04			; change this to determine glide length
;	BCS glide_2
;	;
;	LDA glide_add
;	BMI glide_sub
;	;
;	LDA glide_freq_current
;	CLC
;	ADC glide_freq_diff
;	STA glide_freq_current
;	LDA glide_freq_current+1
;	ADC glide_freq_diff+1
;	STA glide_freq_current+1
;	LDA glide_freq_current+2
;	ADC glide_freq_diff+2
;	STA glide_freq_current+2
;	;
;	LDA glide_freq_current+1
;	LDY glide_freq_current+2
;	;
;	RTS
;	;
;glide_sub
;	LDA glide_freq_current
;	SEC
;	SBC glide_freq_diff
;	STA glide_freq_current
;	LDA glide_freq_current+1
;	SBC glide_freq_diff+1
;	STA glide_freq_current+1
;	LDA glide_freq_current+2
;	SBC glide_freq_diff+2
;	STA glide_freq_current+2
;	;
;	LDA glide_freq_current+1
;	LDY glide_freq_current+2
;	;
;	RTS
;	;
;	; first iteration
;	;
;glide_1	LDA TONE1,x			; look up destination freq
;	ASL a
;	TAY
;	LDA freqs,y
;	STA glide_freq_dest+1
;	LDA freqs+1,y   
;	STA glide_freq_dest+2
;	;
;	LDA TONE_PREV1,x		; look up previous freq
;	ASL a
;	TAY
;	LDA freqs,y
;	STA glide_freq_current+1
;	LDA freqs+1,y   
;	STA glide_freq_current+2
;	;
;	LDA #$00             		; clear low bytes of 24 bit values
;	STA glide_freq_dest
;	STA glide_freq_current
;	STA glide_freq_diff
;	;
;	LDA TONE1,x
;	CMP TONE_PREV1,x
;	BCS glide_down
;	;
;	; up
;	;
;	LDA glide_freq_dest+1		; diff = dest - current
;	SEC
;	SBC glide_freq_current+1
;	STA glide_freq_diff+1
;	LDA glide_freq_dest+2
;	SBC glide_freq_current+2
;	STA glide_freq_diff+2
;	;
;	LDA #$00
;gl_up	STA glide_add
;	;
;	LSR glide_freq_diff+2		; 24 bit div routine
;	ROR glide_freq_diff+1
;	ROR glide_freq_diff		; div2
;	LSR glide_freq_diff+2
;	ROR glide_freq_diff+1
;	ROR glide_freq_diff		; div4
;	;LSR glide_freq_diff+2
;	;ROR glide_freq_diff+1
;	;ROR glide_freq_diff		; div8
;	;LSR glide_freq_diff+2
;	;ROR glide_freq_diff+1
;	;ROR glide_freq_diff
;	;
;	LDA glide_freq_current+1
;	LDY glide_freq_current+2
;	;
;	RTS
;
;glide_down
;	LDA glide_freq_current+1	; diff = current - dest
;	SEC
;	SBC glide_freq_dest+1
;	STA glide_freq_diff+1
;	LDA glide_freq_current+2
;	SBC glide_freq_dest+2
;	STA glide_freq_diff+2
;	;
;	LDA #$80     
;	BNE gl_up			; always jump
;
;glide_freq_current
;	DB 0,0,0	; 24 bit values
;glide_freq_dest
;	DB 0,0,0
;glide_freq_diff
;	DB 0,0,0
;glide_add
;	DB 0
;	
vibrato
	DB $00,$05,$08,$05 
	DB $00,$85,$88,$85
	
snare_freq
	DB $D0,$20,$B0,$10,$80,$70,$60
	DB $50,$40,$30,$20,$10,$08,$00
	
bass_freq
	DW $204,$17F,$131,$D9,$76,$7

;volume_map
;	DB $10,$11,$12,$13,$14,$15,$16,$17,$18
;	DB $10,$11,$12,$13,$14,$15,$16,$17,$18
;	DB $10,$11,$12,$13,$14,$15,$15,$16,$17
;	DB $10,$11,$12,$13,$13,$14,$15,$16,$17
;	;
;	DB $10,$11,$12,$12,$13,$14,$15,$16,$16
;	DB $10,$11,$12,$12,$13,$14,$15,$15,$16
;	DB $10,$11,$11,$12,$13,$14,$14,$15,$16
;	DB $10,$11,$11,$12,$13,$13,$14,$15,$15
;	;
;	DB $10,$11,$11,$12,$12,$13,$14,$14,$15
;	DB $10,$11,$11,$12,$12,$13,$13,$14,$14
;	DB $10,$11,$11,$12,$12,$13,$13,$14,$14
;	DB $10,$10,$11,$11,$12,$12,$13,$13,$14
;	;
;	DB $10,$10,$11,$11,$12,$12,$12,$13,$13
;	DB $10,$10,$11,$11,$11,$12,$12,$12,$13
;	DB $10,$10,$11,$11,$11,$12,$12,$12,$12
;	DB $10,$10,$11,$11,$11,$11,$12,$12,$12
;	;
;	DB $10,$10,$10,$11,$11,$11,$11,$11,$12
;	DB $10,$10,$10,$10,$11,$11,$11,$11,$11
;	DB $10,$10,$10,$10,$10,$11,$11,$11,$11
;	DB $10,$10,$10,$10,$10,$10,$10,$10,$11
;	;
;	DB $10,$10,$10,$10,$10,$10,$10,$10,$10	; 21
;	